import java.awt.*;
import java.lang.*;
import java.io.*;

	class ColonsGui extends Frame {
		TextField a1,a2;			// instncies del GUI
		Scrollbar b1,b2;
		Button c1,c2,c3;
		Label l1,l2,l3,l4,l5,l6,l7,l8,l9,l10,lb1,lb2;
		ColonsCalculs calcul = null;	// instncia de clcul
		ColonsDibuix tauler1 = null;
		ColonsDibuix tauler2 = null;
		String nom = "sensenom.dat";	// aquesta variable ha de ser global
		boolean plot = false;		// opcions del programa
		boolean eps = false;
		int distancia = 10;
		int pc1 = 50;			// variables que recollim del GUI
		int pc2 = 75;
		int aresta = 20;
		int kmax = 100;
		int n = 0;			// variables que surten del clcul
		int nmax = 0;
		int total = 0;

		ColonsGui(String windowTitle) {
			super(windowTitle);			// Posem nom a la finestra
		}

		public void init() {
			setLayout(new GridLayout(0,1,10,10));
			a1 = new TextField(Integer.toString(aresta));
			a2 = new TextField(Integer.toString(kmax));
			b1 = new Scrollbar(Scrollbar.HORIZONTAL,50,1,0,101);
			b2 = new Scrollbar(Scrollbar.HORIZONTAL,50,1,0,101);
			c1 = new Button("Calcular");
			c2 = new Button("Guardar");
			c3 = new Button("Sortir");
			l1 = new Label("Mida del tauler");
			l2 = new Label("Passos de temps");
			l3 = new Label("% Caselles habitables/total");
			l4 = new Label("% Caselles habitades/habitables");
			l5 = new Label("Caselles habitades (al final)");
			l6 = new Label(Integer.toString(n));
			l7 = new Label("Caselles habitables");
			l8 = new Label(Integer.toString(nmax));
			l9 = new Label("Nombre total de caselles");
			l10 = new Label(Integer.toString(total));
			lb1 = new Label(Integer.toString(pc1));
			lb2 = new Label(Integer.toString(pc2));
			add(l1);
			add(a1);
			add(l2);
			add(a2);
			add(l3);
			add(lb1);
			add(b1);
			add(l4);
			add(lb2);
			add(b2);
			add(l5);
			add(l6);
			add(l7);
			add(l8);
			add(l9);
			add(l10);
			add(c1);
			add(c2);
			add(c3);
			pack();
			c2.disable();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcular"))
				calcular();
			if(label.equals("Guardar"))
				guardar();
			if(label.equals("Sortir"))
				System.exit(0);
			return true;
		}


		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			int m;

			aresta = Integer.parseInt(a1.getText());
			kmax = Integer.parseInt(a2.getText());
			calcul = new ColonsCalculs(aresta,pc1,pc2,kmax);
			if(plot) {
				System.out.println("plot '-' with points");
				for(m=0;m<kmax;m++)
					System.out.println(Integer.toString(m) + " " + Double.toString(calcul.traj[m]));
				System.out.println("e");
			}
			n = calcul.n;
			nmax = calcul.nmax;
			total= calcul.total;
			l6.setText(Integer.toString(n));
			l8.setText(Integer.toString(nmax));
			l10.setText(Integer.toString(total));
			if(tauler1==null)
				tauler1 = new ColonsDibuix(this,"Inici",false);
			tauler1.show();
			tauler1.tapete.repaint();
			if(tauler2==null)
				tauler2 = new ColonsDibuix(this,"Final",true);
			tauler2.show();
			tauler2.tapete.repaint();
			c2.enable();
		}

		public void guardar() {
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals
			int m;

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						if(eps) {
							sortida.write("set terminal postscript eps color \n");
							sortida.write("set output '"+nom+".eps' \n");
							sortida.write("plot '-' with points \n");
						}
						for(m=0;m<kmax;m++) {
							linia=Integer.toString(m) + " " + Double.toString(calcul.traj[m]) + "\n";
							sortida.write(linia);
						}
						if(eps) {
							sortida.write("e \n");
						}
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			ColonsDialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;

			if (confirmar == null)
				confirmar = new ColonsDialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals
			File fitxer;
			String nomdirectori = "./";

			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Guardar",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;
		}

		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
				case Event.SCROLL_LINE_UP:
				case Event.SCROLL_LINE_DOWN:
				case Event.SCROLL_PAGE_UP:
				case Event.SCROLL_PAGE_DOWN:
				case Event.SCROLL_ABSOLUTE:
					if (evt.target == b1)
						pc1=lectura(evt);
					if (evt.target == b2)
						pc2=lectura(evt);
			}
	 		return super.handleEvent(evt);
		}

		public int lectura(Event evt) {
			int lectura,sortida;

			lectura = (((Integer)evt.arg).intValue());
			sortida = lectura;
			if(evt.target == b1)
				lb1.setText(Integer.toString(sortida));	// S'ha d'actualitzar l'etiqueta!
			if(evt.target == b2)
				lb2.setText(Integer.toString(sortida));
			return sortida;
		}
	}

	class ColonsDialegConfirmar extends Dialog {
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		ColonsDialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirmar",true);
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.lar");
			l1 = new Label ("  El fitxer ja existeix. Sobreescriure?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) {
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.lar")) {
				opcio = false;
				hide();
			}
			return true;
		}

		public boolean getOpcio() {
		return opcio;
		}
	}

	class ColonsDibuix extends Dialog {
		ColonsTapete tapete;

		ColonsDibuix(Frame progenitora,String title,boolean acabat) {
			super(progenitora,title);
			tapete = new ColonsTapete(progenitora,acabat);
			setLayout(new GridLayout(0,1,10,10));
			add(tapete);
			pack();
		}
	}

	class ColonsTapete extends Canvas {
		ColonsGui mare;
		Dimension minSize;
		boolean acabat;
		int h,i,j,k,w;

		ColonsTapete(Frame progenitora,boolean acabat0) {
			super();
			mare = (ColonsGui) progenitora;
			w = mare.distancia * mare.aresta;
			h = mare.distancia * mare.aresta;
			minSize = new Dimension(w,h);
			acabat = acabat0;
		}

		public Dimension preferredSize() {
			return minimumSize();
		}

		public synchronized Dimension minimumSize() {
			return minSize;
		}

		public void paint(Graphics g){
			for(i=0;i<mare.aresta;i++) {
				for(j=0;j<mare.aresta;j++){
					if(acabat)
						k=mare.calcul.a[i][j];
					else
						k=mare.calcul.c[i][j];
					if(k==2)
						g.fillRect(mare.distancia*i,mare.distancia*j,mare.distancia-1,mare.distancia-1);
					if(k==1)
						g.drawRect(mare.distancia*i,mare.distancia*j,mare.distancia-2,mare.distancia-2);
				}
			}
		}
	}

class Colons {

	public static void main(String args[]) {
		ColonsGui colons = null;

		colons = new ColonsGui("Colons");
		for(int i = 0 ; i < args.length ; i++) {
			if(args[i].equals("-p") || args[i].equals("--gnuplot"))
				colons.plot = true;
			if(args[i].equals("-e") || args[i].equals("--eps"))
				colons.eps = true;
		}
		colons.init();
		colons.show();
	}
}
