import java.lang.*;

/*
-------------------------------------------------------------------------------
Colonitzacio d'un habitat fragmentat
-------------------------------------------------------------------------------
Dades: pc1 (tant per cent de caselles habitables), pc2 (De les caselles
       habitables, percentatge que estan colonitzades), kmax (nombre de
       passos que volem calcular)
Resultats: Per pantalla es veu la situacio inicial. Al fitxer "colons.c"
           es registra la evolucio del sistema (en variables intensives).
           Cada fila representa un pas. A la primera columna hi ha l'ordinal
           del pas i a la segona hi ha el nombre de caselles habitades.
Dades de prova: pc1=60 pc2=50 kmax=100 ==>
                0 104
                1 104
                2 103
                3 100
                4 93
                5 87
               ... ...
Observacions: -
-------------------------------------------------------------------------------
*/

public class ColonsCalculs {
	int n,nmax,total,a[][],c[][],traj[];

	ColonsCalculs(int aresta,int pc1,int pc2,int kmax) {
		int cmax,i,imax,j,jmax,k,da,ba,es,dr,veins,dau,b[][];
		a = new int[aresta][aresta];
		b = new int[aresta][aresta];
		c = new int[aresta][aresta];
		traj = new int[kmax];

/* En Java no fa tanta falta distingir entre la mida fisica i logica dels arrays.
   Nosaltres, no obstant, ho fem... Ens limitem, pero, a taulers quadrats. */

		imax=aresta;
		jmax=aresta;
		total=imax*jmax;

/* Inicialitzem la matriu 'a' */

		for(i=0;i<imax;i++)
			for(j=0;j<jmax;j++){
				a[i][j]=0;
				c[i][j]=0;
			}

/* Omplim aleatoriament la primera matriu */

		nmax=pc1*total/100;
		cmax=pc2*nmax/100;

		for(n=0;n<nmax;n++) {
			do {
				i=alea(imax);
				j=alea(jmax);
			} while(a[i][j]!=0);
			a[i][j]=1;
			c[i][j]=1;
		}

		for(n=0;n<cmax;n++) {
			do {
				i=alea(imax);
				j=alea(jmax);
			} while(a[i][j]!=1);
			a[i][j]=2;
			c[i][j]=2;
		}

		for(k=0;k<kmax;k++) {

/* Reinicialitzem la matriu auxiliar */

			for(i=0;i<imax;i++)for(j=0;j<jmax;j++)b[i][j]=0;

/* Evolucio del sistema */

			for(i=0;i<imax;i++)for(j=0;j<jmax;j++){
				if(a[i][j]==1) {
					veins=0;
					da=(i+imax-1)%imax;
					ba=(i+1)%imax;
					es=(j+jmax-1)%jmax;
					dr=(j+1)%jmax;
					if(a[da][j]==2)veins=1;
					if(a[i][es]==2)veins=1;
					if(a[i][dr]==2)veins=1;
					if(a[ba][j]==2)veins=1;
					dau=veins*alea(5);
					if(dau==4)
						b[i][j]=2;
					else
						b[i][j]=1;
				}
				if(a[i][j]==2) {
					dau=alea(5);
					if(dau==4)
						b[i][j]=1;
					else
						b[i][j]=2;
				}
			}

/* Ara ja podem salvar el resultat a la matriu 'a' */

			for(i=0;i<imax;i++)
				for(j=0;j<jmax;j++)
					a[i][j]=b[i][j];

/* Ara contem el nombre de caselles ocupades a la matriu 'a' */

			n=0;
			for(i=0;i<imax;i++)
				for(j=0;j<jmax;j++)
					if(a[i][j]==2)n++;

			traj[k]=n;

/* Seguent pas de temp */

		}
	}

	public int alea(int i) {
		double a;
		int j,k;

		a = 1000.0*Math.random();
		k = (int) a;
		j = k % i;
		return j;
	}
}
