import java.awt.*;
import java.lang.*;
import java.io.*;

	class PercolaGui extends Frame {
		TextField a1;			// instncies del GUI
		Scrollbar b1;
		Button c1,c3;
		Label l1,l2,l3,l4,l5,l6,lb1;
		PercolaCalculs calcul = null;	// instncia de clcul
		PercolaDibuix tauler = null;
		String nom = "sensenom.dat";	// aquesta variable ha de ser global
		boolean plot = false;		// opcions del programa
		boolean eps = false;
		int distancia = 10;
		int percent = 50;		// variables que recollim del GUI
		int aresta = 20;
		int record = 0;			// variables que surten del clcul
		int nmax = 0;

		PercolaGui(String windowTitle) {
			super(windowTitle);			// Posem nom a la finestra
		}

		public void init() {
			setLayout(new GridLayout(0,1,10,10));
			a1 = new TextField(Integer.toString(aresta));
			b1 = new Scrollbar(Scrollbar.HORIZONTAL,50,1,0,101);
			c1 = new Button("Calcular");
			c3 = new Button("Sortir");
			l1 = new Label("Mida del tauler");
			l2 = new Label("Percentatge ocupat");
			l3 = new Label("Caselles ocupades");
			l4 = new Label(Integer.toString(nmax));
			l5 = new Label("Mida de l'illa mes gran");
			l6 = new Label(Integer.toString(record));
			lb1 = new Label(Integer.toString(percent));
			add(l1);
			add(a1);
			add(l2);
			add(lb1);
			add(b1);
			add(l3);
			add(l4);
			add(l5);
			add(l6);
			add(c1);
			add(c3);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcular"))
				calcular();
			if(label.equals("Sortir"))
				System.exit(0);
			return true;
		}


		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			aresta = Integer.parseInt(a1.getText());
			calcul = new PercolaCalculs(aresta,percent);
			nmax = calcul.nmax;
			record = calcul.record;
			l4.setText(Integer.toString(nmax));
			l6.setText(Integer.toString(record));
			if(tauler==null)
				tauler = new PercolaDibuix(this);
			tauler.show();
			tauler.tapete.repaint();
		}

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
				case Event.SCROLL_LINE_UP:
				case Event.SCROLL_LINE_DOWN:
				case Event.SCROLL_PAGE_UP:
				case Event.SCROLL_PAGE_DOWN:
				case Event.SCROLL_ABSOLUTE:
					if (evt.target == b1)
						percent=lecturab1(evt);
			}
	 		return super.handleEvent(evt);
		}

		public int lecturab1(Event evt) {
			int lectura,sortida;

			lectura = (((Integer)evt.arg).intValue());
			sortida = lectura;
			lb1.setText(Integer.toString(sortida));		// S'ha d'actualitzar l'etiqueta!
			return sortida;
		}
	}

	class PercolaDibuix extends Dialog {
		PercolaTapete tapete;

		PercolaDibuix(Frame progenitora) {
			super(progenitora,"Sistema",false);
			tapete = new PercolaTapete(progenitora);
			setLayout(new GridLayout(0,1,10,10));
			add(tapete);
			pack();
		}
	}

	class PercolaTapete extends Canvas {
		PercolaGui mare;
		Dimension minSize;
		int h,i,j,w;

		PercolaTapete(Frame progenitora) {
			super();
			mare = (PercolaGui) progenitora;
			w = mare.distancia * mare.aresta;
			h = mare.distancia * mare.aresta;
			minSize = new Dimension(w,h);
		}

		public Dimension preferredSize() {
			return minimumSize();
		}

		public synchronized Dimension minimumSize() {
			return minSize;
		}

		public void paint(Graphics g){
			for(i=0;i<mare.aresta;i++) {
				for(j=0;j<mare.aresta;j++)
					if(mare.calcul.a[i][j]==1)
						g.fillRect(mare.distancia*i,mare.distancia*j,mare.distancia-1,mare.distancia-1);
			}
		}
	}

class Percola {

	public static void main(String args[]) {
		PercolaGui percola = null;

		percola = new PercolaGui("Percola");
		for(int i = 0 ; i < args.length ; i++) {
			if(args[i].equals("-p") || args[i].equals("--gnuplot"))
				percola.plot = true;
			if(args[i].equals("-e") || args[i].equals("--eps"))
				percola.eps = true;
		}
		percola.init();
		percola.show();
	}
}

